<template>
  <div class="login_container">
    <div class="login_box">
      <!-- 头像区 -->
      <div class="avatar_box">
        <img src="@/assets/img/toux.png" alt="" />
      </div>
      <!-- 登录表单 -->
      <el-form
        ref="loginFromRef"
        :model="loginForm"
        label-width="0px"
        class="login_form"
        :rules="rules"
      >
        <!-- 用户名 -->
        <el-form-item prop="username">
          <el-input
            v-model="loginForm.username"
            prefix-icon="el-icon-user-solid"
            class="formItem"
          >
          </el-input>
        </el-form-item>
        <!-- 密码 -->
        <el-form-item prop="password">
          <el-input
            v-model="loginForm.password"
            prefix-icon="el-icon-s-tools"
            type="password"
            class="formItem"
            @change="login"
          >
          </el-input>
        </el-form-item>
        <!-- 登录 -->
        <el-form-item class="btns">
          <el-button type="primary" @click="login">登录</el-button>
          <el-button type="info" @click="resetLoginFrom">重置</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      loginForm: {
        username: "",
        password: "",
      },
      rules: {
        username: [
          { required: true, message: "请输入用户名", trigger: "blur" },
          { min: 5, max: 10, message: "3-10个字符", trigger: "blur" },
        ],
        password: [
          { required: true, message: "请输入密码", trigger: "blur" },
          { min: 6, max: 15, message: "6-15个字符", trigger: "blur" },
        ],
      },
    };
  },
  methods: {
    // 重置按钮
    resetLoginFrom() {
      // console.log(this);
      this.$refs.loginFromRef.resetFields();
    },
    // 登录按钮 箭头函数一个参数省略（）
    login() {
      this.$refs.loginFromRef.validate(async (valid) => {
        // console.log(valid);
        if (!valid) return;
        // promis必须使用异步
        const { data: res } = await this.$http.post("login", this.loginForm);

        // console.log(res);

        if (res.meta.status !== 200) return this.$message.error("登陆失败");
        this.$message.success("登陆成功");

        // 1.将登陆成功token保存到客户端sessionStorage
        // 2.项目中除了登陆之外的其他API接口，必须登录之后才能访问
        // token只有当前网页打开期间生效，所以将token保存到sessionStorage
        window.sessionStorage.setItem("token", res.data.token);

        // 通过编程式导肮跳转页面，路由地址 /home
        this.$router.push("/home");
      });
    },
  },
};
</script>

<style scoped>
.login_container {
  height: 100%;
  background-image: url(../assets/img/bgc5.jpg);
  /* // background-repeat: repeat; */
  background-size: 100%;
}
.login_box {
  width: 450px;
  height: 300px;
  background-color: rgba(135, 206, 250, 0.7);
  border-radius: 30px;
  position: absolute;
  left: 50%;
  top: 50%;
  transform: translate(-50%, -50%);
}
.avatar_box {
  position: absolute;
  left: 50%;
  top: -20%;
  transform: translate(-50%);
  border: solid 1px #eee;
  border-radius: 50%;
  height: 130px;
  width: 130px;
  padding: 5px;
  box-shadow: 0 0 10px #ddd;
  background-color: #fff;
}
.avatar_box img {
  width: 100%;
  height: 100%;
  border-radius: 50%;
  background-color: #eee;
}
.login_form {
  position: absolute;
  bottom: 0;
  width: 100%;
  padding: 0 60px;
  box-sizing: border-box;
}
.btns {
  display: flex;
  justify-content: flex-end;
}
.el-input__inner {
  background: transparent !important;
}
</style>>